(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: DAMY.PAS                                                       *)
(*  Obsah: rozmisteni osmi kraloven na sachovnici tak, aby se navzajem     *)
(*         neohrozovaly                                                    *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 30.12.2013                                            *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program osm_kraloven;

var sachovnice:array[1..8] of byte; {Kazda kralovna je v jednom sloupci
          (to je nutne, jinak by se ohrozovaly) a v tomhle poli jsou ulozene
          jejich yove souradnice. Prazdny zbytek sachovnice nas nezajima,
          takze ho nikam neukladame.
          Mimochodem, radky a sloupce tady nehraji roli - sachovnice je
          ctvercova a reseni bude fungovat i vzhuru nohama.}

procedure vypis; {vykresli sachovnici na obrazovku}
var i,j:byte;
Begin
for i:=1 to 8 do
 begin
 for j:=1 to 8 do if sachovnice[j]=i then write('* ') else write('. ');
 writeln;
 end;
End;{vypis}

procedure dal; {presune kralovny do dalsi kombinace}
var i:byte;
    hotovo:boolean;
Begin
i:=1;
 repeat
 hotovo:=true;
 inc(sachovnice[i]);
 if sachovnice[i]>8 then begin
                         sachovnice[i]:=1;
                         inc(i);
                         hotovo:=false;
                         end;
 if i>8 then begin {tohle se stat nemuze, ale radsi at je to osetrene}
             writeln('Prejel jsem konec sachovnice!');
             vypis;
             halt;
             end;
 until hotovo;
{Tech osm souradnic si muzete predstavit jako osmiciferne cislo v osmickove
soustave. Tahle procedura ho proste zvysi o 1.}
End;{dal}

function SediRadky:boolean;
{zkontroluje, jestli se kralovny neohrozuji ve vodorovnem smeru}
var i,j:word;
Begin
sediradky:=true;
for i:=1 to 7 do
 for j:=i+1 to 8 do if sachovnice[i]=sachovnice[j] then begin
                                                        sediradky:=false;
                                                        exit;
                                                        end;
{staci kontrolovat prostor od kazde kralovny doprava, levou stranu uz mame
zkontrolovanou u predchozich kraloven (jestli je to zleva doprava OK, zprava
doleva je to taky)}
End;{sediradky}

function SediUhlopricky:boolean;
{zkontroluje, jestli se kralovny neohrozuji v uhlopricnem smeru}
var i,j:word;
Begin
sediuhlopricky:=true;
for i:=1 to 7 do
 for j:=i+1 to 8 do if (sachovnice[i]+j-i<=8)and(sachovnice[j]=sachovnice[i]+j-i)
                       or (sachovnice[i]-j+i>=1)and(sachovnice[j]=sachovnice[i]-j+i)
                      then begin
                           sediuhlopricky:=false;
                           exit;
                           end;
{kontroluje se jenom pravohorni a pravodolni smer, duvod stejny jako minule}
End;{sediuhlopricky}

BEGIN
writeln('----- Jak bezpecne rozmistit 8 kraloven na jedne sachovnici? -----');
writeln;
write('Pocitam, potrva to par vterin... ');
fillchar(sachovnice,sizeof(sachovnice),1); {dosazenim jineho cisla (1..7) dostanete jina reseni}
 repeat dal until sediradky and sediuhlopricky; {tzv. metoda hrube sily: zkousime jednu kombinaci za druhou, dokud to nevyjde}
writeln('hotovo, tady je vysledek:');
vypis;
writeln;
writeln('Zmackni Enter.');
readln;
END.